import 'dart:async';
import 'dart:io' show Platform;

import 'package:flutter/services.dart';

class PrinterModuleBixolon {
  static const MethodChannel _channel =
  const MethodChannel('printer_module_bixolon');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future create() async {
    if(Platform.isAndroid){
      await _channel.invokeMethod('create');
    } else if(Platform.isIOS){

    }
  }

  static Future connectWifiPrinter({String ipAddress}) async {
    Map params = <String, dynamic>{
      "ipAddress" : ipAddress
    };
    await _channel.invokeMethod('connectWifiPrinter', params);
  }

  static Future connectBluetoothPrinter({String param}) async {
    Map paramsAndroid = <String, dynamic>{
      "deviceName" : param
    };
    Map paramsIos = <String, dynamic>{
      "bdAddrress" : param
    };

    Map parameter;
    if(Platform.isAndroid) {
      parameter = paramsAndroid;
    } else if(Platform.isIOS) {
      parameter = paramsIos;
    }

    await _channel.invokeMethod('connectBluetoothPrinter', parameter);
  }

  static Future disconnectPrinter() async {
    await _channel.invokeMethod('disconnect');
  }

  static Future checkStatus() async {
    if(Platform.isAndroid) {
      String status;
      final bool stats = await _channel.invokeMethod('checkStatus');
      status = stats.toString();
      return status;
    }
  }

  static Future printToBixolon({String text}) async {
    //-Create map for method print---------------------------------------------
    Map params = <String, dynamic>{
      "text" : text
    };
    await _channel.invokeMethod('print', params);
  }
}